package Msm::RSS;

use strict;
use Time::Local;

sub new{
	my $self=shift;
	my $hash = {};
	bless $hash,$self;
	return $hash;
}

sub createSketchRSS{
	my $self = shift;
	my $ms = shift;
	my $file = shift;
	my $rsscode = shift;
	my %file = %{$file};

	my @rss=();
	my $i = 0;
	my $rss_cnt = $ms->getConfig->getConfigData('default','rsscnt') + $[;
	my $datadir = $ms->getDataDir();
	my $plug_dir = $ms->getConfig->getConfigData('default','plugdatadir');
	my $now_time = time;
	my $plug_WDUser = undef;
	foreach my $chk_plug(@{$ms->{plugin}}){
		if ($chk_plug->{name} eq 'WriteDiaryUser') {
			$plug_WDUser = ($chk_plug->{view} == 1);
			last;
		}
	}
	if ($rss_cnt == 0) {
		$rss_cnt = keys(%file);
	}
	foreach my $v(sort {$file{$b} <=> $file{$a}} keys %file){
		my $ret=$ms->getSketchData($v);

		my $uptime = $file{$v};
		my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($uptime);
		$year+=1900;
		$mon++;
		$mon=sprintf('%02d',$mon);
		$day=sprintf('%02d',$day);
		$hour=sprintf('%02d',$hour);
		$min=sprintf('%02d',$min);
		$sec=sprintf('%02d',$sec);
		my $chash={};
		my $title=$ret->{title};
		$title =~ s/(\r\n|\n)$//;

		my $fdctime =$year.'-'.$mon.'-'.$day.'T'.$hour.':'.$min.':'.$sec.'+09:00';

		$v=~/^$datadir(.*)\/(.*)\.txt$/;
		my $filename=$2;
		my $dirname=$1;

		my $fuptime = $fdctime;
		my $WDUser_text = $plug_dir . '/WriteDiaryUser' . $dirname . '/' . $filename . '.txt';
		if (-f $WDUser_text) {
			$uptime = (stat $WDUser_text)[9];
			($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst) = localtime($uptime);
			$year += 1900;
			$mon++;
			$mon  = sprintf('%02d',$mon);
			$day  = sprintf('%02d',$day);
			$hour = sprintf('%02d',$hour);
			$min  = sprintf('%02d',$min);
			$sec  = sprintf('%02d',$sec);

			$fuptime = $year . '-' . $mon . '-' . $day . 'T' . $hour . ':' . $min . ':' . $sec . '+09:00';
		}

		my $author = $plug_WDUser ? ($ms->readPlugData('WriteDiaryUser',$dirname,$filename.'.txt'))[0] : 'no name';

		my $time_difference = $now_time - $uptime;
		my $period = ($time_difference < 604800 ? 'day' : '') || ($time_difference < 2629746 ? 'week' : '') || ($time_difference < 31556952 ? 'month' : '') || 'year';

		my $come = '';
		if ($i < $rss_cnt) {
		$i++;
			$come=$ret->{comment};
			$come =~ s/^------.*?$//gm;
			$come =~ tr/\x0D\x0A//d;
			$come =~ s/<.*?>//g;

			#
			&jcode'convert(\$come,'euc');
			if(length($come) > $ms->getConfig->getConfigData('','rsslength')){
				my $str = substr($come,0,$ms->getConfig->getConfigData('','rsslength'));
				if ($str =~ /\x8F$/ or $str =~ tr/\x8E\xA1-\xFE// % 2) {
					$str = substr($come,0,($ms->getConfig->getConfigData('','rsslength') + 1));
					if ($str =~ /\x8F$/ or $str =~ tr/\x8E\xA1-\xFE// % 2) {
						$str = substr($come,0,($ms->getConfig->getConfigData('','rsslength') + 2));
					}
				}
				$come = $str;
			}
			&jcode'convert(\$come,'sjis');
		};

		$chash={
			title=>$ms->getCGI->escapeHTML($title),
			show=>$ms->getCGI->escapeHTML($come),
			year=>$year,
			mon=>$mon,
			day=>$day,
			hour=>$hour,
			min=>$min,
			file=>$filename,
			dir=>$dirname,
			dctime=>$fdctime,
			uptime=>$fuptime,
			period=>$period,
			author=>$author,
		};

		push @rss,$chash;
	}

	if ($rss_cnt > $#rss + 1 - $[) {
		$rss_cnt = $#rss + 1 - $[;
	}

	my $msname = $ms->getCGI->escapeHTML($ms->getConfig->getConfigData('default','msname'));

	my $script = $ms->getAdConfig->getConfigData('','script');
	my $script_url = $script;
	my $blogid = $ms->getCGI->param('blogid');

	my $sketch_mode = '0';
	my $index_mode = '0';
	if ($ms->getConfig->getConfigData('default','staticmode') eq '1') {
		$sketch_mode = $ms->getConfig->getConfigData('default','staticmode_sketch');
		$index_mode = $ms->getConfig->getConfigData('default','staticmode_index');
	}
	my $index_html_dir = $ms->getConfig->getConfigData('default','staticindexdir');
	my $index_html_url = $ms->getConfig->getConfigData('default','staticindexurl');

	my $generator_url = 'http://www7a.biglobe.ne.jp/~goroh/';

	my $link_host = 'http://' . $ENV{HTTP_HOST};
	my $link_index = $link_host;
	my $site_url = $link_host . $index_html_url;
	my $link_sketch = '';
	my $sketch_id = '';
	my $period = '';

	#rsso
	my $code = 'utf-8';
	if($rsscode ne '1'){
		$code = 'Shift_JIS';
		$script_url =~ s/~/%7E/g;
		$index_html_url =~ s/~/%7E/g;
		$generator_url =~ s/~/%7E/g;
	}

	if ($index_mode eq '1') {
		$link_index .= $index_html_url . 'index.html';
		my $index_html = $index_html_dir . 'index.html';
		if (-f $index_html) {
		 	$now_time = (stat $index_html)[9];
		}
	}
	else {
		$link_index .= $script . '?blogid=' . $blogid;
	}

	my $link_rdf = $link_host . $index_html_url . 'mysketch.rdf';
	my $link_atom = $link_host . $index_html_url . 'mysketch_atom.xml';
	my $adminuser = $ms->getConfig->getConfigData('default','adminuser');

	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($now_time);
	$year+=1900;
	$mon++;
	$mon=sprintf('%02d',$mon);
	$day=sprintf('%02d',$day);
	$hour=sprintf('%02d',$hour);
	$min=sprintf('%02d',$min);
	$sec=sprintf('%02d',$sec);
	my $dctime = $year . '-' . $mon . '-' . $day . 'T' . $hour . ':' . $min . ':' . $sec . '+09:00';

	#$ENV{'TZ'} = $envtmp;
my $xml = <<XML;
<?xml version="1.0" encoding="$code"?>
<rdf:RDF
	xmlns="http://purl.org/rss/1.0/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:sy="http://purl.org/rss/modules/syndication/"
	xml:lang="ja">
 <channel rdf:about="$link_rdf">
  <title>$msname</title>
  <link>$link_index</link>
  <description />
  <dc:date>$dctime</dc:date>
  <items>
   <rdf:Seq>
XML

my $atom = <<XML;
<?xml version="1.0" encoding="$code"?>
<feed xmlns="http://www.w3.org/2005/Atom" xml:lang="ja">
  <title>$msname</title>
  <updated>$dctime</updated>
  <id>$site_url</id>
  <link rel="alternate" type="text/html" hreflang="ja" href="$link_host$index_html_url" />
  <link rel="self" type="application/atom+xml" href="$link_atom" />
  <generator uri="$generator_url" version="$ms->{Version}">MySketch GE</generator>
XML

my $ror = <<XML;
<?xml version="1.0" encoding="$code"?>
<rss version="2.0" xmlns:ror="http://rorweb.com/0.1/">
<channel>
  <title>ROR Sitemap for $site_url</title>
  <link>$link_host$index_html_url</link>
  <item>
    <title>ROR Sitemap for $site_url</title>
    <link>$link_host$index_html_url</link>
    <ror:about>sitemap</ror:about>
    <ror:type>SiteMap</ror:type>
  </item>
  <item>
    <title>$msname</title>
    <link>$link_index</link>
    <ror:updated>$dctime</ror:updated>
    <ror:updatePeriod>day</ror:updatePeriod>
    <ror:sortOrder>0</ror:sortOrder>
    <ror:resourceOf>sitemap</ror:resourceOf>
  </item>
XML


	if ($sketch_mode eq '1') {
		for ($i = $[; $i < $rss_cnt; $i++) {
			$link_sketch = $link_host . $index_html_url . 'category' . $rss[$i]->{dir} . '/' . $rss[$i]->{file} . '.html';
$xml .= <<XML;
    <rdf:li rdf:resource="$link_sketch"/>
XML
		}
	}
	else {
		for ($i = $[; $i < $rss_cnt; $i++) {
			$link_sketch = $link_host . $script . '?t=sketch&amp;blogid=' . $blogid . '&amp;ShowDiary_file=' . $rss[$i]->{dir} . '/' . $rss[$i]->{file};
$xml .= <<XML;
    <rdf:li rdf:resource="$link_sketch"/>
XML
		}
	}

$xml .= <<XML;
   </rdf:Seq>
  </items>
 </channel>
XML


	if ($sketch_mode eq '1') {
		for ($i = $[; $i < $rss_cnt; $i++) {
			$sketch_id = $site_url . 'category' . $rss[$i]->{dir} . '/' . $rss[$i]->{file} . '.html';
			$link_sketch = $link_host . $index_html_url . 'category' . $rss[$i]->{dir} . '/' . $rss[$i]->{file} . '.html';
$xml .= <<XML;
 <item rdf:about="$link_sketch">
  <title>$rss[$i]->{title}</title>
  <link>$link_sketch</link>
  <description>$rss[$i]->{show}</description>
  <dc:date>$rss[$i]->{dctime}</dc:date>
 </item>
XML

$atom .= <<XML;
  <entry>
    <id>$sketch_id</id>
    <title>$rss[$i]->{title}</title>
    <link rel="alternate" type="text/html" href="$link_sketch" />
    <summary>$rss[$i]->{show}</summary>
    <published>$rss[$i]->{dctime}</published>
    <updated>$rss[$i]->{uptime}</updated>
    <author>
      <name>$rss[$i]->{author}</name> 
    </author>
  </entry>
XML

$ror .= <<XML;
  <item>
    <title>$rss[$i]->{title}</title>
    <link>$link_sketch</link>
    <ror:updated>$rss[$i]->{uptime}</ror:updated>
    <ror:updatePeriod>$rss[$i]->{period}</ror:updatePeriod>
    <ror:sortOrder>0</ror:sortOrder>
    <ror:resourceOf>sitemap</ror:resourceOf>
  </item>
XML
		}
	}
	else {
		for ($i =  $[; $i < $rss_cnt; $i++) {
			$sketch_id = $link_host . $script . '?t=sketch&amp;blogid=' . $blogid . '&amp;ShowDiary_file=' . $rss[$i]->{dir} . '/' . $rss[$i]->{file};
			$link_sketch = $link_host . $script_url . '?t=sketch&amp;blogid=' . $blogid . '&amp;ShowDiary_file=' . $rss[$i]->{dir} . '/' . $rss[$i]->{file};
$xml .= <<XML;
 <item rdf:about="$link_sketch">
  <title>$rss[$i]->{title}</title>
  <link>$link_sketch</link>
  <description>$rss[$i]->{show}</description>
  <dc:date>$rss[$i]->{dctime}</dc:date>
 </item>
XML

$atom .= <<XML;
  <entry>
    <id>$sketch_id</id>
    <title>$rss[$i]->{title}</title>
    <link rel="alternate" type="text/html" href="$link_sketch" />
    <summary>$rss[$i]->{show}</summary>
    <published>$rss[$i]->{dctime}</published>
    <updated>$rss[$i]->{uptime}</updated>
    <author>
      <name>$rss[$i]->{author}</name> 
    </author>
  </entry>
XML

$ror .= <<XML;
  <item>
    <title>$rss[$i]->{title}</title>
    <link>$link_sketch</link>
    <ror:updated>$rss[$i]->{uptime}</ror:updated>
    <ror:updatePeriod>$rss[$i]->{period}</ror:updatePeriod>
    <ror:sortOrder>0</ror:sortOrder>
    <ror:resourceOf>sitemap</ror:resourceOf>
  </item>
XML
		}
	}


$xml .= <<XML;
</rdf:RDF>
XML

$atom .= <<XML;
</feed>
XML


	if($rsscode eq '1'){
		#utf8ɃGR[h
		&jcode::convert(\$xml,'utf8','sjis');
		&jcode::convert(\$atom,'utf8','sjis');
	}
	$ms->getIO->writeFile($index_html_dir.'mysketch.rdf',$xml);
	$ms->getIO->writeFile($index_html_dir.'mysketch_atom.xml',$atom);
	undef $xml;
	undef $atom;


	if ($rss_cnt <= $#rss - $[) {
		if ($sketch_mode eq '1') {
			for ($i = $rss_cnt; $i <= $#rss; $i++) {
				$link_sketch = $link_host . $index_html_url . 'category' . $rss[$i]->{dir} . '/' . $rss[$i]->{file} . '.html';
$ror .= <<XML;
  <item>
    <title>$rss[$i]->{title}</title>
    <link>$link_sketch</link>
    <ror:updated>$rss[$i]->{uptime}</ror:updated>
    <ror:updatePeriod>$rss[$i]->{period}</ror:updatePeriod>
    <ror:sortOrder>0</ror:sortOrder>
    <ror:resourceOf>sitemap</ror:resourceOf>
  </item>
XML
			}
		}
		else {
			for ($i =  $[; $i < $rss_cnt; $i++) {
				$link_sketch = $link_host . $script . '?t=sketch&amp;blogid=' . $blogid . '&amp;ShowDiary_file=' . $rss[$i]->{dir} . '/' . $rss[$i]->{file};
$ror .= <<XML;
  <item>
    <title>$rss[$i]->{title}</title>
    <link>$link_sketch</link>
    <ror:updated>$rss[$i]->{uptime}</ror:updated>
    <ror:updatePeriod>$rss[$i]->{period}</ror:updatePeriod>
    <ror:sortOrder>0</ror:sortOrder>
    <ror:resourceOf>sitemap</ror:resourceOf>
  </item>
XML
			}
		}
	}


$ror .= <<XML;
</channel>
</rss>
XML


	if($rsscode eq '1'){
		#utf8ɃGR[h
		&jcode::convert(\$ror,'utf8','sjis');
	}
	$ms->getIO->writeFile($index_html_dir.'sitemap.xml',$ror);


	if ($index_mode eq '1' || $sketch_mode eq '1') {
		$ror =~ s/\.html<\/link>$/\.i\.html<\/link>/gm;
	}
	$ms->getIO->writeFile($index_html_dir.'mobile_sitemap.xml',$ror);
}

1;
